Index: /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/LIM_SRC_3/limthd_dif.F90
===================================================================
--- /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/LIM_SRC_3/limthd_dif.F90	(revision 4332)
+++ /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/LIM_SRC_3/limthd_dif.F90	(revision 4333)
@@ -31,7 +31,5 @@
    PUBLIC   lim_thd_dif   ! called by lim_thd
 
-   REAL(wp) ::   epsi20 = 1e-20     ! constant values
-   REAL(wp) ::   epsi13 = 1e-13     ! constant values
-
+   REAL(wp) ::   epsi10      =  1.e-10_wp    !
    !!----------------------------------------------------------------------
    !! NEMO/LIM3 4.0 , UCL - NEMO Consortium (2011)
@@ -107,5 +105,4 @@
       INTEGER, DIMENSION(kiut) ::   numeqmax   ! reference number of bottom equation
       INTEGER, DIMENSION(kiut) ::   isnow      ! switch for presence (1) or absence (0) of snow
-      REAL(wp) ::   zeps      =  1.e-10_wp    !
       REAL(wp) ::   zg1s      =  2._wp        ! for the tridiagonal system
       REAL(wp) ::   zg1       =  2._wp        !
@@ -114,5 +111,4 @@
       REAL(wp) ::   zraext_s  =  1.e+8_wp     ! extinction coefficient of radiation in the snow
       REAL(wp) ::   zkimin    =  0.10_wp      ! minimum ice thermal conductivity
-      REAL(wp) ::   zht_smin  =  1.e-4_wp     ! minimum snow depth
       REAL(wp) ::   ztmelt_i    ! ice melting temperature
       REAL(wp) ::   zerritmax   ! current maximal error on temperature 
@@ -312,5 +308,5 @@
          IF( thcon_i_swi == 0 ) THEN      ! Untersteiner (1964) formula
             DO ji = kideb , kiut
-               ztcond_i(ji,0)        = rcdic + zbeta*s_i_b(ji,1) / MIN(-zeps,t_i_b(ji,1)-rtt)
+               ztcond_i(ji,0)        = rcdic + zbeta*s_i_b(ji,1) / MIN(-epsi10,t_i_b(ji,1)-rtt)
                ztcond_i(ji,0)        = MAX(ztcond_i(ji,0),zkimin)
             END DO
@@ -318,5 +314,5 @@
                DO ji = kideb , kiut
                   ztcond_i(ji,layer) = rcdic + zbeta*( s_i_b(ji,layer) + s_i_b(ji,layer+1) ) /  &
-                     MIN(-2.0_wp * zeps, t_i_b(ji,layer)+t_i_b(ji,layer+1) - 2.0_wp * rtt)
+                     MIN(-2.0_wp * epsi10, t_i_b(ji,layer)+t_i_b(ji,layer+1) - 2.0_wp * rtt)
                   ztcond_i(ji,layer) = MAX(ztcond_i(ji,layer),zkimin)
                END DO
@@ -326,5 +322,5 @@
          IF( thcon_i_swi == 1 ) THEN      ! Pringle et al formula included: 2.11 + 0.09 S/T - 0.011.T
             DO ji = kideb , kiut
-               ztcond_i(ji,0) = rcdic + 0.090_wp * s_i_b(ji,1) / MIN( -zeps, t_i_b(ji,1)-rtt )   &
+               ztcond_i(ji,0) = rcdic + 0.090_wp * s_i_b(ji,1) / MIN( -epsi10, t_i_b(ji,1)-rtt )   &
                   &                   - 0.011_wp * ( t_i_b(ji,1) - rtt )  
                ztcond_i(ji,0) = MAX( ztcond_i(ji,0), zkimin )
@@ -333,5 +329,5 @@
                DO ji = kideb , kiut
                   ztcond_i(ji,layer) = rcdic + 0.090_wp * ( s_i_b(ji,layer) + s_i_b(ji,layer+1) )   &
-                     &                                  / MIN(-2.0_wp * zeps, t_i_b(ji,layer)+t_i_b(ji,layer+1) - 2.0_wp * rtt)   &
+                     &                                  / MIN(-2.0_wp * epsi10, t_i_b(ji,layer)+t_i_b(ji,layer+1) - 2.0_wp * rtt)   &
                      &                       - 0.0055_wp* ( t_i_b(ji,layer) + t_i_b(ji,layer+1) - 2.0*rtt )  
                   ztcond_i(ji,layer) = MAX( ztcond_i(ji,layer), zkimin )
@@ -339,5 +335,5 @@
             END DO
             DO ji = kideb , kiut
-               ztcond_i(ji,nlay_i) = rcdic + 0.090_wp * s_i_b(ji,nlay_i) / MIN(-zeps,t_bo_b(ji)-rtt)   &
+               ztcond_i(ji,nlay_i) = rcdic + 0.090_wp * s_i_b(ji,nlay_i) / MIN(-epsi10,t_bo_b(ji)-rtt)   &
                   &                        - 0.011_wp * ( t_bo_b(ji) - rtt )  
                ztcond_i(ji,nlay_i) = MAX( ztcond_i(ji,nlay_i), zkimin )
@@ -352,6 +348,6 @@
 
             !-- Snow kappa factors
-            zkappa_s(ji,0)         = rcdsn / MAX(zeps,zh_s(ji))
-            zkappa_s(ji,nlay_s)    = rcdsn / MAX(zeps,zh_s(ji))
+            zkappa_s(ji,0)         = rcdsn / MAX(epsi10,zh_s(ji))
+            zkappa_s(ji,nlay_s)    = rcdsn / MAX(epsi10,zh_s(ji))
          END DO
 
@@ -359,5 +355,5 @@
             DO ji = kideb , kiut
                zkappa_s(ji,layer)  = 2.0 * rcdsn / &
-                  MAX(zeps,2.0*zh_s(ji))
+                  MAX(epsi10,2.0*zh_s(ji))
             END DO
          END DO
@@ -367,13 +363,13 @@
                !-- Ice kappa factors
                zkappa_i(ji,layer)  = 2.0*ztcond_i(ji,layer)/ &
-                  MAX(zeps,2.0*zh_i(ji)) 
-            END DO
-         END DO
-
-         DO ji = kideb , kiut
-            zkappa_i(ji,0)        = ztcond_i(ji,0)/MAX(zeps,zh_i(ji))
-            zkappa_i(ji,nlay_i)   = ztcond_i(ji,nlay_i) / MAX(zeps,zh_i(ji))
+                  MAX(epsi10,2.0*zh_i(ji)) 
+            END DO
+         END DO
+
+         DO ji = kideb , kiut
+            zkappa_i(ji,0)        = ztcond_i(ji,0)/MAX(epsi10,zh_i(ji))
+            zkappa_i(ji,nlay_i)   = ztcond_i(ji,nlay_i) / MAX(epsi10,zh_i(ji))
             !-- Interface
-            zkappa_s(ji,nlay_s)   = 2.0*rcdsn*ztcond_i(ji,0)/MAX(zeps, &
+            zkappa_s(ji,nlay_s)   = 2.0*rcdsn*ztcond_i(ji,0)/MAX(epsi10, &
                (ztcond_i(ji,0)*zh_s(ji) + rcdsn*zh_i(ji)))
             zkappa_i(ji,0)        = zkappa_s(ji,nlay_s)*REAL( isnow(ji) ) &
@@ -389,7 +385,7 @@
                ztitemp(ji,layer)   = t_i_b(ji,layer)
                zspeche_i(ji,layer) = cpic + zgamma*s_i_b(ji,layer)/ &
-                  MAX((t_i_b(ji,layer)-rtt)*(ztiold(ji,layer)-rtt),zeps)
+                  MAX((t_i_b(ji,layer)-rtt)*(ztiold(ji,layer)-rtt),epsi10)
                zeta_i(ji,layer)    = rdt_ice / MAX(rhoic*zspeche_i(ji,layer)*zh_i(ji), &
-                  zeps)
+                  epsi10)
             END DO
          END DO
@@ -398,5 +394,5 @@
             DO ji = kideb , kiut
                ztstemp(ji,layer) = t_s_b(ji,layer)
-               zeta_s(ji,layer)  = rdt_ice / MAX(rhosn*cpic*zh_s(ji),zeps)
+               zeta_s(ji,layer)  = rdt_ice / MAX(rhosn*cpic*zh_s(ji),epsi10)
             END DO
          END DO
@@ -707,5 +703,5 @@
       END DO  ! End of the do while iterative procedure
 
-      IF( ln_nicep ) THEN
+      IF( ln_nicep .AND. lwp ) THEN
          WRITE(numout,*) ' zerritmax : ', zerritmax
          WRITE(numout,*) ' nconv     : ', nconv
@@ -732,5 +728,5 @@
       ! Heat conservation       !
       !-------------------------!
-      IF( con_i ) THEN
+      IF( con_i .AND. jiindex_1d > 0 ) THEN
          DO ji = kideb, kiut
             ! Upper snow value
Index: /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/LIM_SRC_3/limthd_ent.F90
===================================================================
--- /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/LIM_SRC_3/limthd_ent.F90	(revision 4332)
+++ /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/LIM_SRC_3/limthd_ent.F90	(revision 4333)
@@ -36,8 +36,6 @@
    PUBLIC   lim_thd_ent         ! called by lim_thd
 
-   REAL(wp) ::   epsi20 = 1e-20_wp   ! constant values
-   REAL(wp) ::   epsi13 = 1e-13_wp   !
-   REAL(wp) ::   epsi10 = 1e-10_wp   !
-   REAL(wp) ::   epsi06 = 1e-06_wp   !
+   REAL(wp) ::   epsi20 = 1.e-20_wp   ! constant values
+   REAL(wp) ::   epsi10 = 1.e-10_wp   !
    REAL(wp) ::   zzero  = 0._wp      !
    REAL(wp) ::   zone   = 1._wp      !
@@ -122,4 +120,6 @@
       REAL(wp), POINTER, DIMENSION(:,:) ::   zhl0      ! old and new layer thicknesses 
       REAL(wp), POINTER, DIMENSION(:,:) ::   zrl01
+
+      REAL(wp) ::   zinda 
       !!-------------------------------------------------------------------
 
@@ -391,5 +391,6 @@
          DO layer1 = ntop1, nbot1
             DO ji = kideb, kiut
-               zrl01(layer1,layer0) = MAX(0.0,( MIN(zm0(ji,layer0),z_s(ji,layer1))   &
+               zinda = MAX( 0._wp, SIGN( 1._wp , zhl0(ji,layer0) - epsi10 ) )
+               zrl01(layer1,layer0) = zinda * MAX(0.0,( MIN(zm0(ji,layer0),z_s(ji,layer1))   &
                   &                 - MAX(zm0(ji,layer0-1), z_s(ji,layer1-1))) / MAX(zhl0(ji,layer0),epsi10)) 
                q_s_b(ji,layer1) = q_s_b(ji,layer1) + zrl01(layer1,layer0)*qm0(ji,layer0)   &
@@ -407,5 +408,5 @@
       END DO
 
-      IF ( con_i ) THEN
+      IF ( con_i .AND. jiindex_1d > 0 ) THEN
          DO ji = kideb, kiut
             IF ( ABS ( zqts_in(ji) - zqts_fin(ji) ) * r1_rdtice  >  1.0e-6 ) THEN
@@ -429,5 +430,6 @@
       DO jk = 1, nlay_s
          DO ji = kideb, kiut
-            q_s_b(ji,jk) = q_s_b(ji,jk) / MAX( zh_s(ji) , epsi20 )
+            zinda = MAX( 0._wp, SIGN( 1._wp , zh_s(ji) - epsi10 ) )        
+            q_s_b(ji,jk) = zinda * q_s_b(ji,jk) / MAX( zh_s(ji) , epsi10 )
          END DO !ji
       END DO !jk  
@@ -555,5 +557,5 @@
          DO ji = kideb, kiut
             ! Heat conservation
-            zqti_in(ji) = zqti_in(ji) + qm0(ji,jk) * MAX( 0.0 , SIGN(1.0,ht_i_b(ji)-epsi06) ) &
+            zqti_in(ji) = zqti_in(ji) + qm0(ji,jk) * MAX( 0.0 , SIGN(1.0,ht_i_b(ji)-epsi10) ) &
                &                                   * MAX( 0.0 , SIGN( 1. , REAL(nbot0(ji) - jk) ) )
          END DO
@@ -601,9 +603,10 @@
          DO layer1 = ntop1, nbot1
             DO ji = kideb, kiut
-               zrl01(layer1,layer0) = MAX(0.0,( MIN(zm0(ji,layer0),z_i(ji,layer1)) &
+               zinda = MAX( 0._wp, SIGN( 1._wp , zhl0(ji,layer0) - epsi10 ) )
+               zrl01(layer1,layer0) = zinda * MAX(0.0,( MIN(zm0(ji,layer0),z_i(ji,layer1)) &
                   - MAX(zm0(ji,layer0-1), z_i(ji,layer1-1)))/MAX(zhl0(ji,layer0),epsi10))
                q_i_b(ji,layer1) = q_i_b(ji,layer1) & 
                   + zrl01(layer1,layer0)*qm0(ji,layer0) &
-                  * MAX(0.0,SIGN(1.0,ht_i_b(ji)-epsi06)) &
+                  * MAX(0.0,SIGN(1.0,ht_i_b(ji)-epsi10)) &
                   * MAX(0.0,SIGN(1.0,REAL(nbot0(ji)-layer0)))
             END DO
@@ -621,5 +624,5 @@
       END DO
       !
-      IF ( con_i ) THEN
+      IF ( con_i .AND. jiindex_1d > 0 ) THEN
          DO ji = kideb, kiut
             IF ( ABS ( zqti_in(ji) - zqti_fin(ji) ) * r1_rdtice  >  1.0e-6 ) THEN
@@ -646,5 +649,6 @@
       DO jk = 1, nlay_i
          DO ji = kideb, kiut
-            q_i_b(ji,jk) = q_i_b(ji,jk) / MAX( zh_i(ji) , epsi20 )
+            zinda = MAX( 0._wp, SIGN( 1._wp , zh_i(ji) - epsi10 ) )
+            q_i_b(ji,jk) = zinda * q_i_b(ji,jk) / MAX( zh_i(ji) , epsi10 )
          END DO !ji
       END DO !jk  
Index: /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/LIM_SRC_3/limthd_lac.F90
===================================================================
--- /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/LIM_SRC_3/limthd_lac.F90	(revision 4332)
+++ /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/LIM_SRC_3/limthd_lac.F90	(revision 4333)
@@ -36,10 +36,5 @@
    PUBLIC lim_thd_lac     ! called by lim_thd
 
-   REAL(wp) ::   epsi20 = 1e-20_wp   ! constant values
-   REAL(wp) ::   epsi13 = 1e-13_wp   !
-   REAL(wp) ::   epsi11 = 1e-11_wp   !
-   REAL(wp) ::   epsi10 = 1e-10_wp   !
-   REAL(wp) ::   epsi06 = 1e-06_wp   !
-   REAL(wp) ::   epsi03 = 1e-03_wp   !
+   REAL(wp) ::   epsi10 = 1.e-10_wp   !
    REAL(wp) ::   zzero  = 0._wp      !
    REAL(wp) ::   zone   = 1._wp      !
@@ -160,5 +155,5 @@
                   !Energy of melting q(S,T) [J.m-3]
                   e_i(ji,jj,jk,jl) = e_i(ji,jj,jk,jl) / MAX( area(ji,jj) * v_i(ji,jj,jl) ,  epsi10 ) * REAL( nlay_i )
-                  zindb = 1._wp - MAX(  0._wp , SIGN( 1._wp , -v_i(ji,jj,jl) )  )   !0 if no ice and 1 if yes
+                  zindb = 1._wp - MAX(  0._wp , SIGN( 1._wp , -v_i(ji,jj,jl) + epsi10 )  )   !0 if no ice and 1 if yes
                   e_i(ji,jj,jk,jl) = e_i(ji,jj,jk,jl) * unit_fac * zindb
                END DO
@@ -286,10 +281,21 @@
                nbpac = nbpac + 1
                npac( nbpac ) = (jj - 1) * jpi + ji
-               IF( ji == jiindx .AND. jj == jjindx )   jiindex_1d = nbpac
             ENDIF
          END DO
       END DO
 
-      IF( ln_nicep )   WRITE(numout,*) 'lim_thd_lac : nbpac = ', nbpac
+      ! debug point to follow
+      jiindex_1d = 0
+      IF( ln_nicep ) THEN
+         DO ji = mi0(jiindx), mi1(jiindx)
+            DO jj = mj0(jjindx), mj1(jjindx)
+               IF ( tms(ji,jj) * ( qcmif(ji,jj) - qldif(ji,jj) )  >  0._wp ) THEN
+                  jiindex_1d = (jj - 1) * jpi + ji
+               ENDIF
+            END DO
+         END DO
+      ENDIF
+   
+      IF( ln_nicep ) WRITE(numout,*) 'lim_thd_lac : nbpac = ', nbpac
 
       !------------------------------
@@ -499,13 +505,13 @@
          END DO
 
-         IF( ln_nicep ) WRITE(numout,*) ' zv_i_ac : ', zv_i_ac(jiindx, 1:jpl)
+         IF( ln_nicep .AND. jiindex_1d > 0 ) WRITE(numout,*) ' zv_i_ac : ', zv_i_ac(jiindex_1d, 1:jpl)
          DO jl = ice_cat_bounds(jm,1), ice_cat_bounds(jm,2)
             DO ji = 1, nbpac
                zindb = MAX( 0._wp, SIGN( 1._wp , zdv_res(ji) ) )
-               zinda = MAX( 0._wp, SIGN( 1._wp , zat_i_lev(ji) - epsi06 ) )  ! clem
-               zv_i_ac(ji,jl) = zv_i_ac(ji,jl) + zindb * zinda * zdv_res(ji) * za_i_ac(ji,jl) / MAX( zat_i_lev(ji) , epsi06 )
-            END DO
-         END DO
-         IF( ln_nicep )   WRITE(numout,*) ' zv_i_ac : ', zv_i_ac(jiindx, 1:jpl)
+               zinda = MAX( 0._wp, SIGN( 1._wp , zat_i_lev(ji) - epsi10 ) )  ! clem
+               zv_i_ac(ji,jl) = zv_i_ac(ji,jl) + zindb * zinda * zdv_res(ji) * za_i_ac(ji,jl) / MAX( zat_i_lev(ji) , epsi10 )
+            END DO
+         END DO
+         IF( ln_nicep .AND. jiindex_1d > 0 )   WRITE(numout,*) ' zv_i_ac : ', zv_i_ac(jiindex_1d, 1:jpl)
 
          !---------------------------------
@@ -649,8 +655,12 @@
          !     CALL lim_cons_check (et_s_init, et_s_final, 1.0e-3, fieldid) 
          IF( ln_nicep ) THEN
-            WRITE(numout,*) ' vt_i_init : ', vt_i_init(jiindx,jjindx)
-            WRITE(numout,*) ' vt_i_final: ', vt_i_final(jiindx,jjindx)
-            WRITE(numout,*) ' et_i_init : ', et_i_init(jiindx,jjindx)
-            WRITE(numout,*) ' et_i_final: ', et_i_final(jiindx,jjindx)
+            DO ji = mi0(jiindx), mi1(jiindx)
+               DO jj = mj0(jjindx), mj1(jjindx)
+                  WRITE(numout,*) ' vt_i_init : ', vt_i_init (ji,jj)
+                  WRITE(numout,*) ' vt_i_final: ', vt_i_final(ji,jj)
+                  WRITE(numout,*) ' et_i_init : ', et_i_init (ji,jj)
+                  WRITE(numout,*) ' et_i_final: ', et_i_final(ji,jj)
+               END DO
+            END DO
          ENDIF
          !
Index: /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/LIM_SRC_3/limtrp.F90
===================================================================
--- /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/LIM_SRC_3/limtrp.F90	(revision 4332)
+++ /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/LIM_SRC_3/limtrp.F90	(revision 4333)
@@ -36,9 +36,5 @@
    PUBLIC   lim_trp    ! called by ice_step
 
-   REAL(wp)  ::   epsi06 = 1.e-06_wp   ! constant values
-   REAL(wp)  ::   epsi03 = 1.e-03_wp  
    REAL(wp)  ::   epsi10 = 1.e-10_wp  
-   REAL(wp)  ::   epsi16 = 1.e-16_wp
-   REAL(wp)  ::   epsi20 = 1.e-20_wp
    REAL(wp)  ::   rzero  = 0._wp   
    REAL(wp)  ::   rone   = 1._wp
@@ -446,6 +442,6 @@
 
                   ! Switches and dummy variables
-                  zusvosn         = 1.0/MAX( v_s(ji,jj,jl) , epsi16 )
-                  zusvoic         = 1.0/MAX( v_i(ji,jj,jl) , epsi16 )
+                  zusvosn         = 1.0/MAX( v_s(ji,jj,jl) , epsi10 )
+                  zusvoic         = 1.0/MAX( v_i(ji,jj,jl) , epsi10 )
                   zindsn          = MAX( rzero, SIGN( rone, v_s(ji,jj,jl) - epsi10 ) )
                   zindic          = MAX( rzero, SIGN( rone, v_i(ji,jj,jl) - epsi10 ) )
@@ -458,5 +454,5 @@
                   ENDIF
 
-                  zage = MAX( MIN( zbigval, zs0oi(ji,jj,jl) / MAX( a_i(ji,jj,jl), epsi16 ) ), 0._wp  ) * a_i(ji,jj,jl)
+                  zage = MAX( MIN( zbigval, zs0oi(ji,jj,jl) / MAX( a_i(ji,jj,jl), epsi10 ) ), 0._wp  ) * a_i(ji,jj,jl)
                   oa_i (ji,jj,jl)  = zindic * zage 
 
@@ -498,6 +494,6 @@
                at_i(ji,jj) = at_i(ji,jj) + a_i(ji,jj,jl) ! ice concentration
                !
-               zinda = MAX( rzero , SIGN( rone , at_i(ji,jj) - epsi16 ) )
-               icethi(ji,jj) = vt_i(ji,jj) / MAX( at_i(ji,jj) , epsi16 ) * zinda  ! ice thickness
+               zinda = MAX( rzero , SIGN( rone , at_i(ji,jj) - epsi10 ) )
+               icethi(ji,jj) = vt_i(ji,jj) / MAX( at_i(ji,jj) , epsi10 ) * zinda  ! ice thickness
             END DO
          END DO
Index: /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/LIM_SRC_3/limupdate1.F90
===================================================================
--- /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/LIM_SRC_3/limupdate1.F90	(revision 4332)
+++ /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/LIM_SRC_3/limupdate1.F90	(revision 4333)
@@ -48,10 +48,5 @@
    PUBLIC   lim_update1   ! routine called by ice_step
 
-      REAL(wp)  ::   epsi06 = 1.e-06_wp   ! module constants
-      REAL(wp)  ::   epsi04 = 1.e-04_wp   !    -       -
-      REAL(wp)  ::   epsi03 = 1.e-03_wp   !    -       -
       REAL(wp)  ::   epsi10 = 1.e-10_wp   !    -       -
-      REAL(wp)  ::   epsi16 = 1.e-16_wp   !    -       -
-      REAL(wp)  ::   epsi20 = 1.e-20_wp   !    -       -
       REAL(wp)  ::   rzero  = 0._wp       !    -       -
       REAL(wp)  ::   rone   = 1._wp       !    -       -
@@ -108,37 +103,17 @@
       !------------------------------------------------------------------------------
 
-      !---------------------
-      ! Ice dynamics  
-      !---------------------
-      u_ice(:,:) = u_ice(:,:) + d_u_ice_dyn(:,:)
-      v_ice(:,:) = v_ice(:,:) + d_v_ice_dyn(:,:)
- 
-      !-----------------------------
-      ! Update ice and snow volumes  
-      !-----------------------------
-      DO jl = 1, jpl
-         v_i(:,:,jl)  = v_i(:,:,jl) + d_v_i_trp(:,:,jl) 
-         v_s(:,:,jl)  = v_s(:,:,jl) + d_v_s_trp(:,:,jl)
-      END DO
-
-
-      !---------------------------------------------
-      ! Ice concentration and ice heat content
-      !---------------------------------------------
-      a_i (:,:,:)  = a_i (:,:,:) + d_a_i_trp(:,:,:)
-      e_i(:,:,:,:) = e_i(:,:,:,:) + d_e_i_trp(:,:,:,:)  
-
-      !------------------------------
-      ! Snow temperature and ice age
-      !------------------------------
-      e_s (:,:,:,:) = e_s (:,:,:,:) + d_e_s_trp (:,:,:,:)
-      oa_i(:,:,:)   = oa_i(:,:,:)   + d_oa_i_trp(:,:,:)  
-
-      !--------------
-      ! Ice salinity    
-      !--------------
-      IF(  num_sal == 2  ) THEN      ! general case
-         smv_i(:,:,:) = smv_i(:,:,:) + d_smv_i_trp(:,:,:)
-      ENDIF
+      !-----------------
+      !  Trend terms
+      !-----------------
+      d_u_ice_dyn(:,:)     = u_ice(:,:)     - old_u_ice(:,:)
+      d_v_ice_dyn(:,:)     = v_ice(:,:)     - old_v_ice(:,:)
+      d_a_i_trp  (:,:,:)   = a_i  (:,:,:)   - old_a_i  (:,:,:)
+      d_v_s_trp  (:,:,:)   = v_s  (:,:,:)   - old_v_s  (:,:,:)  
+      d_v_i_trp  (:,:,:)   = v_i  (:,:,:)   - old_v_i  (:,:,:)   
+      d_e_s_trp  (:,:,:,:) = e_s  (:,:,:,:) - old_e_s  (:,:,:,:)  
+      d_e_i_trp  (:,:,:,:) = e_i  (:,:,:,:) - old_e_i  (:,:,:,:)
+      d_oa_i_trp (:,:,:)   = oa_i (:,:,:)   - old_oa_i (:,:,:)
+      d_smv_i_trp(:,:,:)   = 0._wp
+      IF(  num_sal == 2  )   d_smv_i_trp(:,:,:)  = smv_i(:,:,:) - old_smv_i(:,:,:)
 
       ! mass and salt flux init (clem)
@@ -160,94 +135,52 @@
       CALL lim_var_glo2eqv
 
-      !---------------------------------
-      ! Classify the pathological cases
-      !---------------------------------
-      ! (1) v_i (new) > 0; d_v_i_thd + v_i(old) > 0 (easy case)
-      ! (3) v_i (new) < 0; d_v_i_thd + v_i(old) > 0 (combined total ablation)
-      ! (5) v_i (old) = 0; d_v_i_trp > 0 (advection of ice in a free-cell)
-      !
-      DO jl = 1, jpl
-         DO jj = 1, jpj
-            DO ji = 1, jpi
-               patho_case(ji,jj,jl) = 1
-               IF( v_i(ji,jj,jl) .LT. 0.0 ) THEN
-                  patho_case(ji,jj,jl) = 3
-               ENDIF
-               IF( ( old_v_i(ji,jj,jl) .LE. epsi10 ) .AND. ( d_v_i_trp(ji,jj,jl) .GT. epsi06 ) ) THEN
-                  patho_case(ji,jj,jl) = 5 ! advection of ice in an ice-free cell
-               ENDIF
-            END DO
-         END DO
-      END DO
-
       !--------------------------------------
       ! 2. Review of all pathological cases
       !--------------------------------------
 
+! clem: useless now
       !-------------------------------------------
       ! 2.1) Advection of ice in an ice-free cell
       !-------------------------------------------
       ! should be removed since it is treated after dynamics now
-
-!      !IF( ln_nicep ) THEN  
-!         WRITE(numout,*) ' limupdate1 - before h correction '
-!         WRITE(numout,*) ' a_i  : ', a_i(12, 44, 1:jpl)
-!         WRITE(numout,*) ' at_i : ', at_i(12,44)
-!         WRITE(numout,*) ' v_i  : ', v_i(12, 44, 1:jpl)
-!         WRITE(numout,*) ' ht_i : ', ht_i(12, 44, 1:jpl)
-!      !ENDIF
+!      zhimax = 5._wp
+!      ! first category
+!      DO jj = 1, jpj
+!         DO ji = 1, jpi
+!            !--- the thickness of such an ice is often out of bounds
+!            !--- thus we recompute a new area while conserving ice volume
+!            zat_i_old = SUM( old_a_i(ji,jj,:) )
+!            zindb     = MAX( 0._wp, SIGN( 1._wp, ABS( d_a_i_trp(ji,jj,1) ) - epsi10 ) ) 
+!            IF( ( ABS( d_v_i_trp(ji,jj,1) ) / MAX( ABS( d_a_i_trp(ji,jj,1) ), epsi10 ) * zindb .GT. zhimax ) &
+!              &   .AND.( ( v_i(ji,jj,1) / MAX( a_i(ji,jj,1), epsi10 ) * zindb ) .GT. zhimax ) &
+!              &   .AND.( zat_i_old .LT. 1.e-6 ) )  THEN ! new line
+!               ht_i(ji,jj,1) = hi_max(1) * 0.5_wp
+!               a_i (ji,jj,1) = v_i(ji,jj,1) / ht_i(ji,jj,1)
+!            ENDIF
+!         END DO
+!      END DO
 !
-      zhimax = 5._wp
-      ! first category
-      DO jj = 1, jpj
-         DO ji = 1, jpi
-            !--- the thickness of such an ice is often out of bounds
-            !--- thus we recompute a new area while conserving ice volume
-            zat_i_old = SUM( old_a_i(ji,jj,:) )
-            zindb     = MAX( 0._wp, SIGN( 1._wp, ABS( d_a_i_trp(ji,jj,1) ) - epsi10 ) ) 
-            IF( ( ABS( d_v_i_trp(ji,jj,1) ) / MAX( ABS( d_a_i_trp(ji,jj,1) ), epsi10 ) * zindb .GT. zhimax ) &
-              &   .AND.( ( v_i(ji,jj,1) / MAX( a_i(ji,jj,1), epsi10 ) * zindb ) .GT. zhimax ) &
-              &   .AND.( zat_i_old .LT. 1.e-6 ) )  THEN ! new line
-               ht_i(ji,jj,1) = hi_max(1) * 0.5_wp
-               a_i (ji,jj,1) = v_i(ji,jj,1) / ht_i(ji,jj,1)
-            ENDIF
-         END DO
-      END DO
-
-
-!      !IF( ln_nicep ) THEN  
-!         at_i(:,:) = 0._wp
-!         DO jl = 1, jpl
-!            at_i(:,:) = a_i(:,:,jl) + at_i(:,:)
-!         END DO
-!         WRITE(numout,*) ' limupdate1 - after h correction 1 '
-!         WRITE(numout,*) ' a_i  : ', a_i(12, 44, 1:jpl)
-!         WRITE(numout,*) ' at_i : ', at_i(12,44)
-!         WRITE(numout,*) ' v_i  : ', v_i(12, 44, 1:jpl)
-!         WRITE(numout,*) ' ht_i : ', ht_i(12, 44, 1:jpl)
-!      !ENDIF
-
-      zhimax = 20._wp
-      ! other categories
-      DO jl = 2, jpl
-         jm = ice_types(jl)
-         DO jj = 1, jpj
-            DO ji = 1, jpi
-               zindb =  MAX( rzero, SIGN( rone, ABS( d_a_i_trp(ji,jj,jl) ) - epsi10 ) ) 
-               ! this correction is very tricky... sometimes, advection gets wrong i don't know why
-               ! it makes problems when the advected volume and concentration do not seem to be 
-               ! related with each other
-               ! the new thickness is sometimes very big!
-               ! and sometimes d_a_i_trp and d_v_i_trp have different sign
-               ! which of course is plausible
-               ! but fuck! it fucks everything up :)
-               IF ( ( ABS( d_v_i_trp(ji,jj,jl) ) / MAX( ABS( d_a_i_trp(ji,jj,jl) ), epsi10 ) * zindb .GT. zhimax ) &
-                  &  .AND. ( v_i(ji,jj,jl) / MAX( a_i(ji,jj,jl), epsi10 ) * zindb ) .GT. zhimax ) THEN
-                  ht_i(ji,jj,jl) = ( hi_max_typ(jl-ice_cat_bounds(jm,1),jm) + hi_max_typ(jl-ice_cat_bounds(jm,1)+1,jm) ) * 0.5_wp
-                  a_i (ji,jj,jl) = v_i(ji,jj,jl) / ht_i(ji,jj,jl)
-               ENDIF
-            END DO ! ji
-         END DO !jj
-      END DO !jl
+!      zhimax = 20._wp
+!      ! other categories
+!      DO jl = 2, jpl
+!         jm = ice_types(jl)
+!         DO jj = 1, jpj
+!            DO ji = 1, jpi
+!               zindb =  MAX( rzero, SIGN( rone, ABS( d_a_i_trp(ji,jj,jl) ) - epsi10 ) ) 
+!               ! this correction is very tricky... sometimes, advection gets wrong i don't know why
+!               ! it makes problems when the advected volume and concentration do not seem to be 
+!               ! related with each other
+!               ! the new thickness is sometimes very big!
+!               ! and sometimes d_a_i_trp and d_v_i_trp have different sign
+!               ! which of course is plausible
+!               ! but fuck! it fucks everything up :)
+!               IF ( ( ABS( d_v_i_trp(ji,jj,jl) ) / MAX( ABS( d_a_i_trp(ji,jj,jl) ), epsi10 ) * zindb .GT. zhimax ) &
+!                  &  .AND. ( v_i(ji,jj,jl) / MAX( a_i(ji,jj,jl), epsi10 ) * zindb ) .GT. zhimax ) THEN
+!                  ht_i(ji,jj,jl) = ( hi_max_typ(jl-ice_cat_bounds(jm,1),jm) + hi_max_typ(jl-ice_cat_bounds(jm,1)+1,jm) ) * 0.5_wp
+!                  a_i (ji,jj,jl) = v_i(ji,jj,jl) / ht_i(ji,jj,jl)
+!               ENDIF
+!            END DO ! ji
+!         END DO !jj
+!      END DO !jl
      
       at_i(:,:) = 0._wp
@@ -255,12 +188,4 @@
          at_i(:,:) = a_i(:,:,jl) + at_i(:,:)
       END DO
-
-!      !IF( ln_nicep ) THEN  
-!         WRITE(numout,*) ' limupdate1 - after h correction 2 '
-!         WRITE(numout,*) ' a_i  : ', a_i(12, 44, 1:jpl)
-!         WRITE(numout,*) ' at_i : ', at_i(12,44)
-!         WRITE(numout,*) ' v_i  : ', v_i(12, 44, 1:jpl)
-!         WRITE(numout,*) ' ht_i : ', ht_i(12, 44, 1:jpl)
-!      !ENDIF
 
       !----------------------------------------------------
@@ -285,8 +210,8 @@
 
                !switches
-               zindb         = MAX( rzero, SIGN( rone, a_i(ji,jj,jl) - epsi06 ) ) 
+               zindb         = MAX( rzero, SIGN( rone, a_i(ji,jj,jl) - epsi10 ) ) 
                !switch = 1 if a_i > 1e-06 and 0 if not
-               zindsn        = MAX( rzero, SIGN( rone, v_s(ji,jj,jl) - epsi06 ) ) !=1 if hs > 1e-6 and 0 if not
-               zindic        = MAX( rzero, SIGN( rone, v_i(ji,jj,jl) - epsi04 ) ) !=1 if hi > 1e-3 and 0 if not
+               zindsn        = MAX( rzero, SIGN( rone, v_s(ji,jj,jl) - epsi10 ) ) !=1 if hs > 1e-10 and 0 if not
+               zindic        = MAX( rzero, SIGN( rone, v_i(ji,jj,jl) - epsi10 ) ) !=1 if hi > 1e-10 and 0 if not
                ! bug fix 25 avril 2007
                zindb         = zindb*zindic
@@ -332,5 +257,4 @@
                !--------------------------------------------
                ! if greater than 0, ice concentration cannot be smaller than 1e-10
-               !clem a_i(ji,jj,jl) = zindb * MAX(zindsn, zindic) * MAX( a_i(ji,jj,jl), epsi06 )
                a_i(ji,jj,jl) = zindb * a_i(ji,jj,jl)
 
@@ -352,5 +276,5 @@
             DO jj = 1, jpj 
                DO ji = 1, jpi
-                  zindic        = MAX( rzero, SIGN( rone, v_i(ji,jj,jl) - epsi04 ) ) 
+                  zindic        = MAX( rzero, SIGN( rone, v_i(ji,jj,jl) - epsi10 ) ) 
                   e_i(ji,jj,jk,jl)= zindic * ( MIN ( MAX ( 0.0, e_i(ji,jj,jk,jl) ), zbigvalue ) )
                END DO ! ji
@@ -370,11 +294,11 @@
          DO ji = 1, jpi
             z_da_ex =  MAX( at_i(ji,jj) - amax , 0.0 )        
-            zindb   =  MAX( rzero, SIGN( rone, at_i(ji,jj) - epsi06 ) ) 
+            zindb   =  MAX( rzero, SIGN( rone, at_i(ji,jj) - epsi10 ) ) 
             DO jl  = 1, jpl
-               z_da_i = a_i(ji,jj,jl) * z_da_ex / MAX( at_i(ji,jj), epsi06 ) * zindb
+               z_da_i = a_i(ji,jj,jl) * z_da_ex / MAX( at_i(ji,jj), epsi10 ) * zindb
                a_i(ji,jj,jl) = MAX( 0._wp, a_i(ji,jj,jl) - z_da_i )
                !
-               zinda   =  MAX( rzero, SIGN( rone, a_i(ji,jj,jl) - epsi06 ) ) 
-               ht_i(ji,jj,jl) = v_i(ji,jj,jl) / MAX( a_i(ji,jj,jl), epsi06 ) * zinda
+               zinda   =  MAX( rzero, SIGN( rone, a_i(ji,jj,jl) - epsi10 ) ) 
+               ht_i(ji,jj,jl) = v_i(ji,jj,jl) / MAX( a_i(ji,jj,jl), epsi10 ) * zinda
                !v_i(ji,jj,jl) = ht_i(ji,jj,jl) * a_i(ji,jj,jl) ! makes ice shrinken but should not be used
             END DO
@@ -412,6 +336,6 @@
                      !clem smv_i(ji,jj,jl)  =  MAX(MIN((rhoic-rhosn)/rhoic*sss_m(ji,jj),smv_i(ji,jj,jl)),0.1 * v_i(ji,jj,jl) )
                      smv_i(ji,jj,jl) = MAX( MIN( s_i_max * v_i(ji,jj,jl), smv_i(ji,jj,jl) ), s_i_min * v_i(ji,jj,jl) )
-                     i_ice_switch    = 1._wp - MAX( 0._wp, SIGN( 1._wp, -v_i(ji,jj,jl) + epsi20 ) )
-                     smv_i(ji,jj,jl) = i_ice_switch * smv_i(ji,jj,jl) + s_i_min * ( 1._wp - i_ice_switch ) * v_i(ji,jj,jl)
+                     i_ice_switch    = 1._wp - MAX( 0._wp, SIGN( 1._wp, -v_i(ji,jj,jl) ) )
+                     smv_i(ji,jj,jl) = i_ice_switch * smv_i(ji,jj,jl) !+ s_i_min * ( 1._wp - i_ice_switch ) * v_i(ji,jj,jl)
                   END DO ! ji
                END DO ! jj
@@ -512,5 +436,4 @@
             CALL prt_ctl(tab2d_1=old_oa_i   (:,:,jl)        , clinfo1= ' lim_update1  : old_oa_i    : ')
             CALL prt_ctl(tab2d_1=d_oa_i_trp (:,:,jl)        , clinfo1= ' lim_update1  : d_oa_i_trp  : ')
-            CALL prt_ctl(tab2d_1=REAL(patho_case(:,:,jl))   , clinfo1= ' lim_update1  : Path. case  : ')
 
             DO jk = 1, nlay_i
